#Analysis for Chapter 10

#Arzheimer(2009)͌̕ʂ̍Č

#f[^̓ǂݍ 
multi<-read.table("nonimp.tab", header=T)
attach(multi)

#_ؕЃf
library(lme4)
result<-lmer(rexvote~male+age1+age2+age4+mye1+mye2+farmerown+worker+retired+unemployed+zlrs+euschlecht+zsatisdmo+disp+lfed1+zasylumseekers+zsur+zreplacementrate+rmax+salienzmean+rvar+as.factor(sortcountry)+(1|kontext), family=binomial(link="logit"))
summary(result)


#_ؕЁ{_Wf
result2<-lmer(rexvote~male+age1+age2+age4+mye1+mye2+farmerown+worker+retired+unemployed+zlrs+euschlecht+zsatisdmo+disp+lfed1+zasylumseekers+zsur+zreplacementrate+rmax+salienzmean+rvar+(1+zsatisdmo|sortcountry), family=binomial(link="logit"))
summary(result2)

#Ƃ̌W̐l̕\ 
coef(result1)

#}10.1A10.2̍쐬 
zsatisdmox <- seq(1,4,by=1)
effect<- matrix(coef(result2)[[1]][,1], 4,14,byrow=T)+matrix(zsatisdmox,4,1,byrow=T)%*%matrix(coef(result2)[[1]][,14], 1,14,byrow=T)
figdata <- data.frame(cbind(c(1:4),effect))

jpeg(filename="multi1.jpg")
matplot(figdata[,1], figdata[,2:15], type="l", xlab="`s", ylab="log(p/1-p)ւ̉e",ylim=c(-9,-1),lty=c(1), lwd=c(1), col=c("black"), axes = F)
axis(side=1, at=seq(0,4,1))
axis(side=2, at=seq(-10,-1,1), tck=0, labels = F)
dev.off()

jpeg(filename="multi2.jpg")
matplot(figdata[,1], figdata[,c(10, 12, 13)], type="l", xlab="`s", ylab="log(p/1-p)ւ̉e",ylim=c(-9,-1),lty=c(1, 2, 3), col=c("black"), axes = F)
axis(side=1, at=seq(0,4,1))
axis(side=2, at=seq(-10,-1,1), tck=0, labels = F)
legend(1, max(-1), legend=colnames<-c("MVA", "I_", "mEFC"), lty=c(1,2,3), bty="n")
dev.off()


#}10.3̍쐬 

b <- coef(result2)

library(arm)

#
prsatdemgrx <-numeric() 
for(i in 1:4)
{
  predgr <- invlogit(b[[1]][9,1]+b[[1]][9,2]*male+b[[1]][9,3]*age1+b[[1]][9,4]*age2+b[[1]][9,5]*age4+b[[1]][9,6]*mye1+b[[1]][9,7]*mye2+b[[1]][9,8]*farmerown+b[[1]][9,9]*worker+b[[1]][9,10]*retired+b[[1]][9,11]*unemployed+b[[1]][9,12]*zlrs+b[[1]][9,13]*euschlecht+b[[1]][9,14]*i+b[[1]][9,15]*disp+b[[1]][9,16]*lfed1+b[[1]][9,17]*zasylumseekers+b[[1]][9,18]*zsur+b[[1]][9,19]*zreplacementrate+b[[1]][9,20]*rmax+b[[1]][9,21]*salienzmean+b[[1]][9,22]*rvar)
  mpredgr <- mean(predgr[!is.na(predgr)])
  prsatdemgrx=append(prsatdemgrx, mpredgr)
}

prsatdemnlx <-numeric() 
for(i in 1:4)
{
  prednl <- invlogit(b[[1]][12,1]+b[[1]][12,2]*male+b[[1]][12,3]*age1+b[[1]][12,4]*age2+b[[1]][12,5]*age4+b[[1]][12,6]*mye1+b[[1]][12,7]*mye2+b[[1]][12,8]*farmerown+b[[1]][12,9]*worker+b[[1]][12,10]*retired+b[[1]][12,11]*unemployed+b[[1]][12,12]*zlrs+b[[1]][12,13]*euschlecht+b[[1]][12,14]*i+b[[1]][12,15]*disp+b[[1]][12,16]*lfed1+b[[1]][12,17]*zasylumseekers+b[[1]][12,18]*zsur+b[[1]][12,19]*zreplacementrate+b[[1]][12,20]*rmax+b[[1]][12,21]*salienzmean+b[[1]][12,22]*rvar)
  mprednl <- mean(prednl[!is.na(prednl)])
  prsatdemnlx=append(prsatdemnlx, mprednl)
}

prsatdemnox <-numeric()           
for(i in 1:4)
{
  predno <- invlogit(b[[1]][13,1]+b[[1]][13,2]*male+b[[1]][13,3]*age1+b[[1]][13,4]*age2+b[[1]][13,5]*age4+b[[1]][13,6]*mye1+b[[1]][13,7]*mye2+b[[1]][13,8]*farmerown+b[[1]][13,9]*worker+b[[1]][13,10]*retired+b[[1]][13,11]*unemployed+b[[1]][13,12]*zlrs+b[[1]][13,13]*euschlecht+b[[1]][13,14]*i+b[[1]][13,15]*disp+b[[1]][13,16]*lfed1+b[[1]][13,17]*zasylumseekers+b[[1]][13,18]*zsur+b[[1]][13,19]*zreplacementrate+b[[1]][13,20]*rmax+b[[1]][13,21]*salienzmean+b[[1]][13,22]*rvar)
  mpredno <- mean(predno[!is.na(predno)])
  prsatdemnox=append(prsatdemnox, mpredno)
}

xaxis<-c(1:4)

predict <-data.frame(XAXIS=xaxis, prsatdemgr=prsatdemgrx, prsatdemnl=prsatdemnlx, prsatdemno=prsatdemnox)

jpeg(filename="graph3.jpg")
matplot(predict[,1], predict[,2:4], type="l", xlab="`s", ylab="ɉE}[Ӑ}m",lty=c(1,2,3), ylim=c(0,.25), lwd=c(1), col=c("black"), axes = F)
axis(side=1, at=seq(0,4,1))
axis(side=2, at=seq(0,.25,.05))
legend(1, max(.25), legend=colnames<-c("MVA", "I_", "mEFC"), lty=c(1,2,3), bty="n")
dev.off()

