#6͂RR[h

#Oyefusi(2008)͂̍̕Č

#f[^̓ǂݍ
library(foreign)
oyefusi<-read.dta("jpr data oyefusi.dta")
attach(oyefusi)

#WbgiFull modelj 
result_oyefusi1<-glm(participation~oilsize+oilsizesq+ethnic+unemployment+farmoil+access+grievance+infrastructure+conflict+ethnic+distance+government+education+income+studentship+marriage+asset+asset_immobility+rivers_state+delta_state, family=binomial(link="logit"))
summary(result_oyefusi1) 

#WbgiDV=participation, IV=ethnic, marriage)

result_oyefusi2<-glm(participation~ethnic+marriage, family=binomial(link="logit"))
summary(result_oyefusi2)

#茋ʂ̌Wۑ
b<-coef (result_oyefusi2)

#ۑꂽ茋ʂ̌WlɓƗϐ̊el^ꂽ̎QӐ}\̐mvZ
library(arm)

#CW̎QӐ}\̐m 
preth1mar1 <-invlogit(b[1]+b[2]*1+b[3]*1)

#CW̎QӐ}\̐m 
preth1mar0 <-invlogit(b[1]+b[2]*1+b[3]*0)

#CW̎QӐ}\̐m 
preth0mar1 <-invlogit(b[1]+b[2]*0+b[3]*1)

#CW̎QӐ}\̐m 
preth0mar0 <-invlogit(b[1]+b[2]*0+b[3]*0)

preth1mar1
preth1mar0
preth0mar1
preth0mar0

#WbgiDV=participation, IV=ethnic, education, income)
result_oyefusi3<-glm(participation~ethnic+education+income, family=binomial(link="logit"))
summary(result_oyefusi3)

#茋ʂ̌Wۑ
b2<-coef (result_oyefusi3)

#CW̎ω(1-7jɑΉQӐ}\m̕ω*1 
preth1inc1 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*1)
preth1inc2 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*2)
preth1inc3 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*3)
preth1inc4 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*4)
preth1inc5 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*5)
preth1inc6 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*6)
preth1inc7 <- invlogit(b2[1] + b2[2]*1 + b2[3]*education + b2[4]*7)

#CW̎ω(1-7jɑΉQӐ}\m̕ω*2 
preth0inc1 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*1)
preth0inc2 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*2)
preth0inc3 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*3)
preth0inc4 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*4)
preth0inc5 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*5)
preth0inc6 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*6)
preth0inc7 <- invlogit(b2[1] + b2[2]*0 + b2[3]*education + b2[4]*7)

#x̌ʂ𕽋ϒlɌŒ*3 
preth1 <- c(mean(preth1inc1[!is.na(preth1inc1)]), mean(preth1inc2[!is.na(preth1inc2)]), mean(preth1inc3[!is.na(preth1inc3)]), mean(preth1inc4[!is.na(preth1inc4)]), mean(preth1inc5[!is.na(preth1inc5)]), mean(preth1inc6[!is.na(preth1inc6)]), mean(preth1inc7[!is.na(preth1inc7)]))
preth0 <- c(mean(preth0inc1[!is.na(preth0inc1)]), mean(preth0inc2[!is.na(preth0inc2)]), mean(preth0inc3[!is.na(preth0inc3)]), mean(preth0inc4[!is.na(preth0inc4)]), mean(preth0inc5[!is.na(preth0inc5)]), mean(preth0inc6[!is.na(preth0inc6)]), mean(preth0inc7[!is.na(preth0inc7)]))

#L*1-3̍Ƃ[vgčsꍇ 

preth1 <-numeric() 
for(i in 1:7)
{
  pred1 <- invlogit(b2[1]+b2[2]*1+b2[3]*education+b2[4]*i)
  mpred1 <- mean(pred1[!is.na(pred1)])
  preth1=append(preth1, mpred1)
}

preth0 <-numeric() 
for(i in 1:7)
{
  pred0 <- invlogit(b2[1]+b2[2]*0+b2[3]*education+b2[4]*i)
  mpred0 <- mean(pred0[!is.na(pred0)])
  preth0=append(preth0, mpred0)
}

#}̂߂̃f[^t[쐬 
xaxis<-c(1:7)
predict <-data.frame(XAXIS=xaxis, PRETH1=preth1, PRETH0=preth0)

#}6.3̍쐬 
jpeg(filename="predict.jpg")
matplot(predict[,1], predict[,2:3], type="b", xlab="", ylab="Qӎu\̗\m", 
lty=c(1,2), lwd=c(2,1), col=c("black","black"), pch=c(15, 17))
                                               
legend(4, max(.4), legend=colnames<-c("CW", "CW"), lty=c(1,2), lwd=c(2,1), pch=c(15, 17), bty="n")
dev.off()

